import gtk
import gconf

class Pref:
    def __init__(self):
        # load interfaz from xml file
        glade = gtk.Builder()
        glade.add_from_file("app.xml")

        # get widgets
        self.window_prefer = glade.get_object ("window_prefer")
        self.button_close = glade.get_object ("button_close")
        self.button_save = glade.get_object ("button_save")
        self.button_load = glade.get_object ("button_load")
        self.entry_color = glade.get_object ("entry_color")
        self.entry_font = glade.get_object ("entry_font")

        # signals
        self.window_prefer.connect ("delete_event",self.on_delete_event)
        self.button_close.connect ("clicked",self.on_clicked_button_close)
        self.button_save.connect ("clicked",self.on_clicked_button_save)
        self.button_load.connect ("clicked",self.on_clicked_button_load)

        # show all widgets
        self.window_prefer.show_all()

    def main(self):
        gtk.main()

    def load_preferences(self):
        try:
            client = gconf.client_get_default()

            color = client.get_string('/apps/appsample/color')
            font = client.get_string('/apps/appsample/font')
            self.entry_color.set_text(color)
            self.entry_font.set_text(font)
            print "loaded"
        except:
            print "ups"

    def save_preferences(self):
        color = self.entry_color.get_text()
        font = self.entry_font.get_text()

        client = gconf.client_get_default()

        client.set_string('/apps/appsample/color', color)
        client.set_string('/apps/appsample/font', font)
        print "saved"

    def on_delete_event (self,widget,event,user_data=None):        
        print "Bye bye!"
        gtk.main_quit()

    def on_clicked_button_close (self,button,user_data=None):        
        print "Bye bye!"
        gtk.main_quit()        

    def on_clicked_button_save (self,button,user_data=None):        
        self.save_preferences()

    def on_clicked_button_load (self,button,user_data=None):        
        self.load_preferences()


pref = Pref ()
pref.main()
