import gtk
import gobject
import sqlite3

class Db():
    def __init__ (self,db):
        self.conn = sqlite3.connect(db)
        
    def select_data (self,sql):
        cursor = self.conn.cursor()
        cursor.execute(sql)
        return cursor

class Model():
    def __init__ (self):
        self.liststore = gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_STRING)

    def get_model (self):
        return self.liststore
        
    def set_data (self,data0,data1):
        iter = self.liststore.append()
        self.liststore.set (iter,0,data0,1,data1)
        
class App():
    def __init__(self):        
        self.db = None
        
        # create model (liststore)
        self.model = Model()
        
        # get interfaz from file
        builder = gtk.Builder()
        builder.add_from_file("app.xml")
        
        # get widgets
        self.window = builder.get_object ("window")
        self.button_get_data = builder.get_object ("button_get_data")
        self.button_quit = builder.get_object ("button_quit")
        self.treeview = builder.get_object ("treeview")
        
        # setting treeview
        self.treeview.set_rules_hint (True)
        self.treeview.set_model (self.model.get_model())
        
        # create columns
        col = gtk.TreeViewColumn ("RUT")
        col.set_resizable (True)
        self.treeview.append_column (col)
        cell =  gtk.CellRendererText()
        cell.set_property('editable',True)
        col.pack_start (cell,True)
        col.add_attribute (cell,"text",0)
        
        col = gtk.TreeViewColumn ("Correo")
        col.set_resizable (True)
        self.treeview.append_column (col)
        cell =  gtk.CellRendererText()
        cell.set_property('editable',True)
        col.pack_start (cell,True)
        col.add_attribute (cell,"text",1)
        
        # connect signals
        self.button_get_data.connect ("clicked",self.on_button_get_data)
        self.button_quit.connect ("clicked",self.on_button_quit)
        
        self.window.set_title ("sqlite sample")
        self.window.set_position(1)
        
        # show all widgets
        self.window.show_all()
    
    def main(self):
        gtk.main()        

    def on_button_quit(self,button,user_data=None):
        self.db.conn.close()
        gtk.main_quit()
            
    def on_button_get_data (self,button,user_data=None):
        self.model.liststore.clear()
        
        # connect to database
        print "connecting to database..."
        self.db = Db("db-test")
        
        # consultar
        print "get data..."
        cursor = self.db.select_data ("select * from asistentes")
        
        for row in cursor:
            print row[0],row[1]
            self.model.set_data(row[0],row[1])
    

if __name__ == "__main__":
    app = App()
    app.main()
