import gtk
import vte

APPNAME = "My Terminal"
VERSION = "0.1"
DEFAULT_TMP ="/tmp"


class Terminal:
    def __init__(self):
        # load interfaz from xml file
        glade = gtk.Builder()
        glade.add_from_file("app.xml")

        self.window = glade.get_object ("window")
        self.notebook = glade.get_object ("notebook")
        self.button_go = glade.get_object ("button_go")
        self.entry_user = glade.get_object ("entry_user")
        self.entry_host = glade.get_object ("entry_host")
        self.radiobutton_ssh = glade.get_object ("radiobutton_ssh")
        self.radiobutton_telnet = glade.get_object ("radiobutton_telnet")

        # set title to window
        self.window.set_title (APPNAME)

        # signals        
        self.window.connect ("delete_event", self.on_delete_event)
        self.button_go.connect ("clicked", self.on_button_go_clicked)

        # show all widget
        self.window.show_all()
    
    def main(self):
        gtk.main()

    def on_delete_event (self, widget, event, user_data = None):
        gtk.main_quit ()

    def on_button_go_clicked (self, data = None):
        user = self.entry_user.get_text()
        ip = self.entry_host.get_text()

        if (len(user)>0 and len(ip)>0):
            if self.radiobutton_ssh.get_active():
                command = "ssh"

            if self.radiobutton_telnet.get_active():
                command = "telnet"

            scroll = gtk.VScrollbar()
            hbox = gtk.HBox()
            hbox.pack_start(scroll,False,False,0)

            terminal = vte.Terminal()
            terminal.fork_command (command,['bash','-l',user,ip],None,DEFAULT_TMP, False, False, False)

            hbox.pack_start(terminal,True,True,0)

            label = gtk.Label(ip)
            page = self.notebook.append_page (hbox,label)
            self.notebook.set_current_page (page)

            hbox.show()
            terminal.show()


if __name__ == "__main__":
    terminal = Terminal ()
    terminal.main()
